{ plots 3D pour le fun                                                          }
{ 28.08.02 : FO : premire version                                              }
{ =============== A FAIRE ===================================================== }
{ * activer/dsactiver les grilles                                              }
{ * pouvoir tourner autour d'un point autre que (0 0 0)                         }
{ * curseur pour rgler l'challe en z                                          }
{ * possibilit n1: glisser des offsets                                        }
{   sous la forme de curseurs gradus de xmin  xmax                            }
{   et shifter les valeurs X,Y et Z d'autant                                    }
unit Graph3D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  ComCtrls, ExtCtrls, JvComponent, JvFormPlace, EditData,
  Spin, EditReal, GR32_RangeBars, GLScene, GLGraph, GLObjects, GLMisc, GLTexture,
  GLCadencer, Geometry, GLWin32Viewer, GLSpaceText;

type
  TGraph3Dform = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    HeightField1: THeightField;
    YZGrid: TXYZGrid;
    XZGrid: TXYZGrid;
    XYGrid: TXYZGrid;
    Timer1: TTimer;
    GLCadencer1: TGLCadencer;
    JvFormPlace1: TJvFormPlace;
    Panel1: TPanel;
    choixspectre: TComboBox;
    Panel2: TPanel;
    ZoffsetGaugeBar: TGaugeBar;
    XoffsetGaugeBar: TGaugeBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    YoffsetGaugeBar: TGaugeBar;
    Label5: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    ComboBox1: TComboBox;
    ShowAxisBox: TCheckBox;
    CheckBox1: TCheckBox;
    CBCentered: TCheckBox;
    Xarrow: TArrowLine;
    Yarrow: TArrowLine;
    Zarrow: TArrowLine;
    Xtext: TSpaceText;
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MiseAjourChoixSpectre(var ListeDeSpectres:spectList);
    procedure choixspectreChange(Sender: TObject);
    procedure choixspectreDropDown(Sender: TObject);
    procedure ShowAxisBoxClick(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure XoffsetGaugeBarChange(Sender: TObject);
    procedure YoffsetGaugeBarChange(Sender: TObject);
    procedure CBCenteredClick(Sender: TObject);
    procedure ZoffsetGaugeBarChange(Sender: TObject);
  private
    procedure UpdateHeightField;
    { Dclarations prives }
    procedure Formula4(const x, y: Single; var z: Single;
      var color: TColorVector; var texPoint: TTexPoint);
  public
    { Dclarations publiques }
    mx, my : Integer;
  end;

var
  Graph3Dform: TGraph3Dform;
  XOffset,Yoffset,ZOffset:integer;
  idxCrt:integer;
  Zmin,Zmax:double;

implementation

{$R *.DFM}

procedure TGraph3Dform.UpdateHeightField;
var vind:integer;
begin
  vind:=deuxd.indexof(choixspectre.text);
  if vind>=1 then
  begin
     idxCrt:=vind;
     { mise a jour des extremits des curseurs }
     XoffsetGaugeBar.Min:=0;XoffsetGaugeBar.Max:=deuxd.spect[idxCrt].X-1;
     YoffsetGaugeBar.Min:=0;YoffsetGaugeBar.Max:=deuxd.spect[idxCrt].Y-1;
     deuxd.spect[idxCrt].minmax(zmin,zmax);
     ZoffsetGaugeBar.Min:=round(zmin);ZoffsetGaugeBar.Max:=round(zmax);
     Zoffset:=ZoffsetGaugeBar.position;
     with HeightField1.XSamplingScale do begin
      Min:=0-XOffSet;
      Max:=deuxd.spect[idxCrt].X-1-XOffSet;
      origin:=deuxd.spect[idxCrt].X/2  end;
     with HeightField1.YSamplingScale do begin
      Min:=0-YOffSet;
      Max:=deuxd.spect[idxCrt].Y-1-YOffSet;
      origin:=deuxd.spect[idxCrt].Y/2 end;
     with HeightField1 do begin
      XSamplingScale.Step:=1;
      YSamplingScale.Step:=1; end;
     with HeightField1 do begin
      Scale.X:=1/deuxd.spect[idxCrt].X;
      Scale.Y:=1/deuxd.spect[idxCrt].Y;
      Scale.Z:=1/(zmax-zmin); end;

{     with XYGrid do begin
      XZGrid.YSamplingScale.Origin:=64;
      YZGrid.XSamplingScale.Origin:=64; end; }
     with XYGrid do begin
      XsamplingScale.min:=0-XOffSet;
      XsamplingScale.max:=deuxd.spect[idxCrt].X-1-XOffSet;
      YsamplingScale.min:=0-YOffSet;
      YsamplingScale.max:=deuxd.spect[idxCrt].Y-1-YOffSet; end;
     with YZGrid do begin
      YsamplingScale.min:=0-YOffSet;
      YsamplingScale.max:=deuxd.spect[idxCrt].Y-1-YOffSet;
      ZsamplingScale.min:=zmin-ZOffSet;
      ZsamplingScale.max:=zmax-ZOffSet;
      ZsamplingScale.step:=1 {(zmax-zmin)/10;}       end;
     with XZGrid do begin
      XsamplingScale.min:=0-XOffSet;
      XsamplingScale.max:=deuxd.spect[idxCrt].X-1-XOffSet;
      ZsamplingScale.min:=zmin-ZOffSet;
      ZsamplingScale.max:=zmax-ZOffSet;
      ZsamplingScale.step:=1 {(zmax-zmin)/10;}       end;
     with Xarrow do begin
      Scale.X:=1/deuxd.spect[idxCrt].X;
      Scale.Y:=1/deuxd.spect[idxCrt].Y;
      Scale.Z:=1/(zmax-zmin); end;
     with Yarrow do begin
      Scale.X:=1/deuxd.spect[idxCrt].X;
      Scale.Y:=1/deuxd.spect[idxCrt].Y;
      Scale.Z:=1/(zmax-zmin); end;
     with Zarrow do begin
      Scale.X:=1/deuxd.spect[idxCrt].X;
      Scale.Y:=1/deuxd.spect[idxCrt].Y;
      Scale.Z:=1/(zmax-zmin); end;


{    AutoScale(deuxd.spect[vind]);
    GenSampleData(choixspectre.text);
    PaintData;
    CursorsReplot; }
  end;
end;

procedure TGraph3Dform.FormCreate(Sender: TObject);
begin
   // start with first formula
   HeightField1.OnGetHeight:=Formula4;
   // no per-vertex coloring
   ComboBox1.ItemIndex:=0;
   XOffset:=64;YOffset:=64;ZOffset:=64;
   UpDateHeightField;
   left:=0;top:=0;width:=523;height:=250;
   WindowState:=wsMinimized;
end;

procedure TGraph3Dform.Formula4(const x, y: Single; var z: Single;
  var color: TColorVector; var texPoint: TTexPoint);
begin
   // first formula
   z:=VectorNorm(x, y);
{   z:=deuxd.spect[idxCrt].data[round((x+0.63)/0.01),round((y+0.63)/0.01),0].z/100; }
{   z:=deuxd.spect[idxCrt].data[round((x+63)),round((y+63)),0].z/100; }
{   z:=deuxd.spect[idxCrt].data[round((x)),round((y)),0].z/100; }
   z:=deuxd.spect[idxCrt].data[round((x+Xoffset)),round((y+Yoffset)),0].z-ZoffSet;
   VectorLerp(clrBlue, clrRed, (z+1)/2, color);
end;

procedure TGraph3Dform.CheckBox1Click(Sender: TObject);
begin
   // enable two sided surface
   if CheckBox1.Checked then
      HeightField1.Options:=HeightField1.Options+[hfoTwoSided]
   else HeightField1.Options:=HeightField1.Options-[hfoTwoSided];
end;

procedure TGraph3Dform.ComboBox1Change(Sender: TObject);
begin
   // change per vertex color mode
   case ComboBox1.ItemIndex of
      0 : HeightField1.ColorMode:=hfcmNone;
      1 : HeightField1.ColorMode:=hfcmEmission;
      2 : HeightField1.ColorMode:=hfcmDiffuse;
   end;
end;

procedure TGraph3Dform.CheckBox2Click(Sender: TObject);
begin
   GLLightSource1.Shining:=CheckBox2.Checked;
end;


procedure TGraph3Dform.Timer1Timer(Sender: TObject);
begin
   // Display number of triangles used in the mesh
   // You will note that this number quickly gets out of hand if you are
   // using large high-resolution grids
   Caption:=Format('%d Triangles - %.2f FPS',
                   [HeightField1.TriangleCount, GLSceneViewer1.FramesPerSecond]);
   GLSceneViewer1.ResetPerformanceMonitor;
end;

// following code takes care of camera movement, see camera & movement demos
// for explanations and more samples

procedure TGraph3Dform.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   mx:=x; my:=y;
end;

procedure TGraph3Dform.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
   if Shift<>[] then begin
      GLCamera1.MoveAroundTarget(my-y, mx-x);
      mx:=x; my:=y;
   end;
end;

procedure TGraph3Dform.Button1Click(Sender: TObject);
var Xmin,Xmax,Ymin,Ymax,tailleX,TailleY:integer;
begin
   with HeightField1.XSamplingScale do begin
      Min:=0;
      Max:=deuxd.spect[idxCrt].X-1;
      origin:=deuxd.spect[idxCrt].X/2  end;
   with HeightField1.YSamplingScale do begin
      Min:=0;
      Max:=deuxd.spect[idxCrt].Y-1;
      origin:=deuxd.spect[idxCrt].Y/2 end;
   with HeightField1 do begin
      XSamplingScale.Step:=1;
      YSamplingScale.Step:=1; end;
   with HeightField1 do begin
      Scale.X:=1/deuxd.spect[idxCrt].X;
      Scale.Y:=1/deuxd.spect[idxCrt].Y; end;
end;

{ mise a jour de la combo ChoixSpectre  partir de la liste des spectres 2D }
{ INPUT: la liste de spectres "deuxd" en gnral                            }
{        a passer en var parce que la taille risque de devenir gigantesque  }
procedure TGraph3Dform.MiseAjourChoixSpectre(var ListeDeSpectres:spectList);
var i:integer;
begin
{reinitialisation des items a chaque ouverture du combo}
   choixSpectre.items.clear;
   for i:=1 to totalspectre do
   begin
      if ListeDeSpectres<>nil then
      if deuxd.spect[i]<>nil then
      choixSpectre.items.add(ListeDeSpectres.spect[i].nom);
   end;
end;

procedure TGraph3Dform.choixspectreChange(Sender: TObject);
begin
   UpDateHeightField;
end;

procedure TGraph3Dform.choixspectreDropDown(Sender: TObject);
begin
  if sender=choixspectre then  MiseAjourChoixSpectre(deuxd);
end;

procedure TGraph3Dform.ShowAxisBoxClick(Sender: TObject);
begin
  HeightField1.ShowAxes:=ShowAxisBox.checked;
end;

procedure TGraph3Dform.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  GLCamera1.AdjustDistanceToTarget(Power(1.1, WheelDelta/120));
end;


procedure TGraph3Dform.XoffsetGaugeBarChange(Sender: TObject);
begin
   XOffSet:=XOffsetGaugeBar.position;
   UpdateHeightField
end;

procedure TGraph3Dform.YoffsetGaugeBarChange(Sender: TObject);
begin
   YOffSet:=YOffsetGaugeBar.position;
   UpdateHeightField
end;

procedure TGraph3Dform.ZoffsetGaugeBarChange(Sender: TObject);
begin
   ZOffSet:=ZOffsetGaugeBar.position;
   UpdateHeightField
end;


procedure TGraph3Dform.CBCenteredClick(Sender: TObject);
begin
   if CBCentered.Checked then begin
      XZGrid.YSamplingScale.Origin:=0;
      YZGrid.XSamplingScale.Origin:=0;
   end else begin
      XZGrid.YSamplingScale.Origin:=-YOffSet;
      YZGrid.XSamplingScale.Origin:=-XOffSet;
   end;
end;


end.
