unit Surfaces2D;
{ Unit de trac de surfaces 2D }
{ Dcrt STABLE par F. OTT, le 28.10.2000 }
{ A FAIRE }
{ Xmin et Xmax ne sont definis nulle part mais sont disponibles en tant que variables ?!?!? }
{ bug au dpart si les facteurs d'challes ne sont pas dfinis                        }
{ Fixer le fonctionnement des curseurs                                                 }
{ donner la possibilit de se dplacer avec le curseur (plus fin)                      }
{ *** Coupe en "diagonale" ***                                                         }
{ EDOUARD: dans la combo, proposer sommes entre curseurs et sommes circulaires         }
{ bouton pour "rescaler" les data sur la palette                                       }
{ Amliorer les modif dynamiques de la palette                                         }
{ optimiser l'affichage des echelles sur le graph1D                                    }
{ amliorer les initialisations (definir les facteurs d'echelle                        }
{ EN STOCK: on a une fenetre "loupe" sympa                                             }
{ EN STOCK: on a une fenetre pour superposer des bitmaps                               }
{           sera utile si on veut faire des masques ou comparer dex figures            }
{ MODIFICATIONS                                                                        }
{ le 29.10.00                                                                          }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, JPeg, ExtDlgs, StdCtrls, G32, G32_Bytemaps, G32_Image, G32_Layers,
  G32_RangeBars, G32_Filters, G32_Transforms, G32_Polygons, EditReal, xyGraph;

const
     coupeHorz1 = 1; { indices des graphes pour les diffrentes coupes }
     coupeVert1 = 2;
     coupeHorz2 = 3;
     coupeVert2 = 4;
     coupeDiagX  = 5;
     coupeDiagY  = 6;


type Tableau3D=array of array of double;

type
  TMainForm = class(TForm)
    SidePanel: TPanel;
    MainMenu: TMainMenu;
    mnFileNew: TMenuItem;
    mnFile: TMenuItem;
    mnFileOpen: TMenuItem;
    mnLayers: TMenuItem;
    mnNewBitmapLayer: TMenuItem;
    mnDelete: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    pnlImage: TPanel;
    ScaleCombo: TComboBox;
    Label1: TLabel;
    Panel2: TPanel;
    ImageInterpolate: TCheckBox;
    pnlBitmapLayer: TPanel;
    Panel3: TPanel;
    Label2: TLabel;
    LayerOpacity: TGaugeBar;
    LayerInterpolate: TCheckBox;
    mnNewBitmapRGBA: TMenuItem;
    LayerRescale: TButton;
    LayerResetScale: TButton;
    Cropped: TCheckBox;
    mnNewCustomLayer: TMenuItem;
    mnMagnifier: TMenuItem;
    PnlMagn: TPanel;
    Label3: TLabel;
    Panel4: TPanel;
    MagnOpacity: TGaugeBar;
    SaveDialog1: TSaveDialog;
    Label4: TLabel;
    MagnMagnification: TGaugeBar;
    Label5: TLabel;
    MagnRotation: TGaugeBar;
    MagnInterpolate: TCheckBox;
    mnSimpleDrawing: TMenuItem;
    mnArrange: TMenuItem;
    mnBringFront: TMenuItem;
    mnSendBack: TMenuItem;
    N1: TMenuItem;
    mnLevelUp: TMenuItem;
    mnLevelDown: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    mnScaled: TMenuItem;
    Replot1: TMenuItem;
    PaletteCombo: TComboBox;
    ScaleBar: TGaugeBar;
    StretchButton: TButton;
    PnlPos: TPanel;
    Panel5: TPanel;
    Xpos1: TEditReal;
    Xpos2: TEditReal;
    Label6: TLabel;
    Label7: TLabel;
    Panel1: TPanel;
    ImgView: TImgView32;
    XYcoupe: TxyGraph;
    PaletteCenterGaugeBar: TGaugeBar;
    PaletteAmplitudeGaugeBar: TGaugeBar;
    Trash1: TMenuItem;
    CreateData3D1: TMenuItem;
    TypeGraphCombo: TComboBox;
    Ypos2: TEditReal;
    Ypos1: TEditReal; 
    Label8: TLabel;
    Zval1: TEditReal;
    Zval2: TEditReal;
    ZmaxBox: TEditReal;
    ZminBox: TEditReal;
    Label9: TLabel;
    ZlogCheckBox: TCheckBox;
    procedure mnFileNewClick(Sender: TObject);
    procedure mnFileOpenClick(Sender: TObject);
    procedure mnNewBitmapLayerClick(Sender: TObject);
    procedure mnDeleteClick(Sender: TObject);
    procedure ScaleComboChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnLayersClick(Sender: TObject);
    procedure ImageInterpolateClick(Sender: TObject);
    procedure LayerOpacityChange(Sender: TObject);
    procedure LayerInterpolateClick(Sender: TObject);
    procedure ImgViewPaintStage(Sender: TObject; StageNum: Cardinal);
    procedure FormCreate(Sender: TObject);
    procedure mnNewBitmapRGBAClick(Sender: TObject);
    procedure LayerRescaleClick(Sender: TObject);
    procedure LayerResetScaleClick(Sender: TObject);
    procedure ImgViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CroppedClick(Sender: TObject);
    procedure mnMagnifierClick(Sender: TObject);
    procedure MagnChange(Sender: TObject);
    procedure mnSimpleDrawingClick(Sender: TObject);
    procedure mnArrangeClick(Sender: TObject);
    procedure mnScaledClick(Sender: TObject);
    procedure mnReorder(Sender: TObject);
    procedure Replot1Click(Sender: TObject);
    procedure PaletteComboChange(Sender: TObject);
    procedure ScaleBarChange(Sender: TObject);
    procedure StretchButtonClick(Sender: TObject);
    procedure PaletteCenterGaugeBarChange(Sender: TObject);
    procedure PaletteAmplitudeGaugeBarChange(Sender: TObject);
    procedure CreateData3D1Click(Sender: TObject);
    procedure Zval1Change(Sender: TObject);
    procedure TypeGraphComboChange(Sender: TObject);
    procedure ZminBoxExit(Sender: TObject);
    procedure ZmaxBoxExit(Sender: TObject);
    procedure ZlogCheckBoxClick(Sender: TObject);
  private
    FSelection: TPositionedLayer;
    procedure SetSelection(Value: TPositionedLayer);
    procedure WMEraseBkgnd(var Msg: TMessage); message WM_ERASEBKGND;
  protected
    RBLayer: TRubberbandLayer;
    function CreatePositionedLayer: TPositionedLayer;
    procedure LayerMouseDown(Sender: TObject; Buttons: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RBMouseDown(Sender: TObject; Buttons: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintMagnifierHandler(Sender: TObject; Buffer: TBitmap32);
    procedure PaintSimpleDrawingHandler(Sender: TObject; Buffer: TBitmap32);
  public
    CurrentScale:double;
    CurrentX,CurrentY:integer;
    Xcursor1, Ycursor1, Xcursor2, Ycursor2:integer; { positions des curseurs 1 et 2 }
    MesData3D:Tableau3D;
    Xmesh,Ymesh:integer;
    xmin,xmax,ymin,ymax:double;
    Zmin,Zmax:double;
    DataSet: TByteMap;
    palGrayscale: TPalette32;
    palGreens: TPalette32;
    palReds: TPalette32;
    palRainbow: TPalette32;
    palCustom:Tpalette32;
    { variables polygones }
    PolygonH1, PolygonV1, PolygonH2, PolygonV2, PolygonD: TPolygon32;
    BitmapList: TBitmap32List; { quoi qu'est ce ??? }
    procedure GenPalettes;
    procedure GenSampleData(W, H: Integer);
    procedure PaintData;

    procedure CreateNewImage(AWidth, AHeight: Integer; FillColor: TColor32);
    procedure OpenImage(const FileName: string);
    property Selection: TPositionedLayer read FSelection write SetSelection;
    { trac des polygones }
    procedure draw;
    procedure UpdateCourbesAafficher;
  end;

var
  MainForm: TMainForm;

implementation

uses NewImageUnit, RGBALoaderUnit, Math;

{$R *.DFM}

{ TForm1 }

procedure TMainForm.GenPalettes;
var
  i: Integer;
  f: Single;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    palGrayscale[i] := HSLtoRGB(0, 0, f * 0.9 + 0.1);
    palGreens[i] := HSLtoRGB(f * 0.4, 0.5, f * 0.4 + 0.2);
    palReds[i] := HSLtoRGB(0.8 + f * 0.3 , 0.7 + f * 0.3, f * 0.85 + 0.1);
    palRainbow[i] := HSLtoRGB(f * 1.2, 0.6, f * 0.8 + 0.2);
    PalCustom[i]:= HSLtoRGB(0, 0, PaletteAmplitudeGaugeBar.position/100 * f + PaletteCenterGaugeBar.position/100);
  end;
end;

procedure TMainForm.GenSampleData(W, H: Integer);
var
  i, j: Integer;
  aux,aux1:double;

  function Clamp(FloatVal: Extended): Byte;
  begin
    if FloatVal <= 0 then Result := 0
    else if FloatVal >= 1 then Result := 255
    else Result := Round(FloatVal * 255);
  end;

begin
if ZlogCheckBox.checked=false
then begin
     aux:=Zmax-Zmin;
     DataSet.SetSize(W, H);
     for j := 0 to H - 1 do
         for i := 0 to W - 1 do
         begin
         // just some noise
         DataSet[i, j] := Clamp((MesData3D[i,j]-Zmin)/aux);
         end;
     end
else begin
     aux:=Log10(Zmax)-Log10(Zmin);
     DataSet.SetSize(W, H);
     for j := 0 to H - 1 do
         for i := 0 to W - 1 do
         begin
         // just some noise
         aux1:=MesData3D[i,j];
         if aux1>0
         then DataSet[i, j] := Clamp((log10(aux1)-log10(zmin))/aux)
         else DataSet[i, j] := 0;
         end;
     end

end;


procedure TMainForm.CreateNewImage(AWidth, AHeight: Integer; FillColor: TColor32);
begin
  with ImgView do
  begin
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.SetSize(AWidth, AHeight);
    Bitmap.Clear(FillColor);
    pnlImage.Visible := not Bitmap.Empty;
  end;
end;

{ A MODIFIER }
function TMainForm.CreatePositionedLayer: TPositionedLayer;
var
  P: TPoint;
begin
  // get coordinates of the center of viewport
  with ImgView.GetViewportRect do
    P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

  Result := TPositionedLayer.Create(ImgView.Layers);
  Result.Location := FloatRect(P.X - 32, P.Y - 32, P.X + 32, P.Y + 32);
  Result.Scaled := True;
  Result.MouseEvents := True;
  Result.OnMouseDown := LayerMouseDown;
end;

procedure TMainForm.CroppedClick(Sender: TObject);
begin
  if Selection is TBitmapLayer then
    TBitmapLayer(Selection).Cropped := Cropped.Checked;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  // by default, PST_CLEAR_BACKGND is executed at this stage,
  // which, in turn, calls ExecClearBackgnd method of ImgView.
  // Here I substitute PST_CLEAR_BACKGND with PST_CUSTOM, so force ImgView
  // to call the OnPaintStage event instead of performing default action.
  with ImgView.PaintStages[0]^ do
  begin
    if Stage = PST_CLEAR_BACKGND then Stage := PST_CUSTOM;
  end;
  { rajout de F. OTT }
  { on introduit une palette et une image Bitmap }
  PaletteCombo.ItemIndex := 0;
  GenPalettes;
  DataSet := TByteMap.Create;
  { cration des curseurs }
  PolygonH1 := TPolygon32.Create;
  PolygonV1 := TPolygon32.Create;
  PolygonH2 := TPolygon32.Create;
  PolygonV2 := TPolygon32.Create;
  PolygonD := TPolygon32.Create;
  UpdateCourbesAafficher
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Selection := nil;
  RBLayer := nil;
  DataSet.Free;
  { destruction des polygones }
  PolygonH1.Free;PolygonV1.Free;
  PolygonH2.Free;PolygonV2.Free;
  PolygonD.Free;
end;

procedure TMainForm.ImageInterpolateClick(Sender: TObject);
const
  STRETCH_FILTER: array [Boolean] of TStretchFilter = (sfNearest, sfLinear);
begin
  ImgView.Bitmap.StretchFilter := STRETCH_FILTER[ImageInterpolate.Checked];
end;

procedure TMainForm.ImgViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var largeur,hauteur:double;
    i,aux:integer;
    deltax,deltay:double;
    H,V:TFixedPoint;
begin
  Selection := nil; { what is it ? }
  { conversion d'une position en pixel vers une position en absolue du graph }
  { on suppose que le bitmap est toujours centr sur la fenetre ImgView      }
  { Taille de la fenetre graphique                                           }
  largeur:=abs(ImgView.GetViewPortRect.Left-ImgView.GetViewPortRect.Right);
  hauteur:=abs(ImgView.GetViewPortRect.Top-ImgView.GetViewPortRect.Bottom);
  { trac des coupes sur le graph 2D }
  { achtung, on n'a pas le dernier point ?!?! }
  { il faudrait avoir une matrice de taille Xmesh+1 }
  deltax:=(xmax-xmin)/Xmesh;
  deltay:=(ymax-ymin)/Ymesh;
  { on purge tous les graph }
  if Button = mbLeft then { si boutton souris gauche }
  begin
  Xpos1.value:=(Xmesh/2)+(X-largeur/2)/CurrentScale;
  Ypos1.value:=(Ymesh/2)+(Y-hauteur/2)/CurrentScale;
  CurrentX:=Floor(Xpos1.value);XCursor1:=CurrentX;
  CurrentY:=Floor(Ypos1.value);YCursor1:=CurrentY;
     xyCoupe[CoupeHorz1].clear;xyCoupe[CoupeHorz1].holdupdates:=true;
     For i:=0 to Xmesh do xyCoupe[CoupeHorz1][xmin+deltax*i]:=MesData3D[i,CurrentY];
     xyCoupe[CoupeHorz1].holdupdates:=false;
     xyCoupe[CoupeVert1].clear;xyCoupe[CoupeVert1].holdupdates:=true;
     For i:=0 to Ymesh do xyCoupe[CoupeVert1][ymin+deltay*i]:=MesData3D[CurrentX,i];
     xyCoupe[CoupeVert1].holdupdates:=false;
  Zval1.value:=MesData3D[CurrentX,CurrentY];
  end;
  if Button = mbRight then { si boutton souris gauche }
  begin
  Xpos2.value:=(Xmesh/2)+(X-largeur/2)/CurrentScale;
  Ypos2.value:=(Ymesh/2)+(Y-hauteur/2)/CurrentScale;
  CurrentX:=Floor(Xpos2.value);XCursor2:=CurrentX;
  CurrentY:=Floor(Ypos2.value);YCursor2:=CurrentY;
     xyCoupe[CoupeHorz2].clear;xyCoupe[CoupeHorz2].holdupdates:=true;
     For i:=0 to Xmesh do xyCoupe[CoupeHorz2][xmin+deltax*i]:=MesData3D[i,CurrentY];
     xyCoupe[CoupeHorz2].holdupdates:=false;
     xyCoupe[CoupeVert2].clear;xyCoupe[CoupeVert2].holdupdates:=true;
     For i:=0 to Ymesh do xyCoupe[CoupeVert2][ymin+deltay*i]:=MesData3D[CurrentX,i];
     xyCoupe[CoupeVert2].holdupdates:=false;
  Zval2.value:=MesData3D[CurrentX,CurrentY];
  end;
  { calcul de la coupe en diagonaleX de l'image }
  if (typeGraphCombo.text='DiagonaleX') or (typeGraphCombo.text='DiagonaleY') then
  begin
  xyCoupe[CoupeDiagX].clear;xyCoupe[CoupeDiagX].holdupdates:=true;
  if abs(Xcursor2-Xcursor1)>abs(Ycursor2-Ycursor1)
  then if Xcursor2>Xcursor1
       then For i:=Xcursor1 to Xcursor2 do
            begin aux:=round(Ycursor1+(Ycursor2-Ycursor1)*(i-Xcursor1)/(Xcursor2-Xcursor1));
                  xyCoupe[CoupeDiagX][i]:=MesData3D[i,aux] end
       else For i:=Xcursor2 to Xcursor1 do
            begin aux:=round(Ycursor2+(Ycursor1-Ycursor2)*(i-Xcursor2)/(Xcursor1-Xcursor2));
                  xyCoupe[CoupeDiagX][i]:=MesData3D[i,aux] end
  else if Ycursor2>Ycursor1
       then For i:=Ycursor1 to Ycursor2 do
            begin aux:=round(Xcursor1+(Xcursor2-Xcursor1)*(i-Ycursor1)/(Ycursor2-Ycursor1));
                  xyCoupe[CoupeDiagX][aux]:=MesData3D[aux,i] end
       else For i:=Ycursor2 to Ycursor1 do
            begin aux:=round(Xcursor2+(Xcursor1-Xcursor2)*(i-Ycursor2)/(Ycursor1-Ycursor2));
                  xyCoupe[CoupeDiagX][aux]:=MesData3D[aux,i] end;
  xyCoupe[CoupeDiagX].holdupdates:=false;
  { calcul de la coupe en diagonaleY de l'image }
  xyCoupe[CoupeDiagY].clear;xyCoupe[CoupeDiagY].holdupdates:=true;
  if abs(Xcursor2-Xcursor1)>abs(Ycursor2-Ycursor1)
  then if Xcursor2>Xcursor1
       then For i:=Xcursor1 to Xcursor2 do
            begin aux:=round(Ycursor1+(Ycursor2-Ycursor1)*(i-Xcursor1)/(Xcursor2-Xcursor1));
                  xyCoupe[CoupeDiagY][aux]:=MesData3D[i,aux] end
       else For i:=Xcursor2 to Xcursor1 do
            begin aux:=round(Ycursor2+(Ycursor1-Ycursor2)*(i-Xcursor2)/(Xcursor1-Xcursor2));
                  xyCoupe[CoupeDiagY][aux]:=MesData3D[i,aux] end
  else if Ycursor2>Ycursor1
       then For i:=Ycursor1 to Ycursor2 do
            begin aux:=round(Xcursor1+(Xcursor2-Xcursor1)*(i-Ycursor1)/(Ycursor2-Ycursor1));
                  xyCoupe[CoupeDiagY][i]:=MesData3D[aux,i] end
       else For i:=Ycursor2 to Ycursor1 do
            begin aux:=round(Xcursor2+(Xcursor1-Xcursor2)*(i-Ycursor2)/(Ycursor1-Ycursor2));
                  xyCoupe[CoupeDiagY][i]:=MesData3D[aux,i] end;
  xyCoupe[CoupeDiagY].holdupdates:=false;
  end;


  { essai de trac de polygones sur l'image }
  if Button = mbLeft then
  begin
  PolygonH1.Clear;{PolygonH.newline; }
  PolygonH1.Add(FixedPoint(0, CurrentY));PolygonH1.Add(FixedPoint(Xmesh+100, CurrentY));
  PolygonV1.Clear;{PolygonH.newline; }
  PolygonV1.Add(FixedPoint(CurrentX, 0));PolygonV1.Add(FixedPoint(CurrentX, Ymesh+100));
  end;
  if Button = mbRight then
  begin
  PolygonH2.Clear;{PolygonH.newline; }
  PolygonH2.Add(FixedPoint(0, CurrentY));PolygonH2.Add(FixedPoint(Xmesh+2, CurrentY));
  PolygonV2.Clear;{PolygonH.newline; }
  PolygonV2.Add(FixedPoint(CurrentX, 0));PolygonV2.Add(FixedPoint(CurrentX, Ymesh+2));
  end;
  PolygonD.Clear;
  { cration de la coupe en diagonale }
  if (typeGraphCombo.text='DiagonaleX') or (typeGraphCombo.text='DiagonaleY') then
  begin PolygonD.Add(FixedPoint(Xcursor1,Ycursor1));PolygonD.Add(FixedPoint(Xcursor2,Ycursor2));  end;
  draw;
end;

procedure TMainForm.ImgViewPaintStage(Sender: TObject; StageNum: Cardinal);
var
  I, J: Integer;
  P: PColor32;
  OddY: Boolean;
begin
  with ImgView.Buffer do
  begin
    P := Pointer(Bits);
    for J := 0 to Height - 1 do
    begin
      OddY := Odd(J shr 3);
      for I := 0 to Width - 1 do
      begin
        if Odd(I shr 3) = OddY then P^ := $FFFFFFFF
        else P^ := $FFB0B0B0;
        Inc(P);
      end;
    end;
  end;
end;

procedure TMainForm.LayerInterpolateClick(Sender: TObject);
const
  STRETCH_FILTER: array [Boolean] of TStretchFilter = (sfNearest, sfLinear);
begin
  if Selection is TBitmapLayer then
  begin
    TBitmapLayer(Selection).Bitmap.StretchFilter := STRETCH_FILTER[LayerInterpolate.Checked];
  end;
end;

procedure TMainForm.LayerMouseDown(Sender: TObject; Buttons: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Sender <> nil then Selection := TPositionedLayer(Sender);
end;

procedure TMainForm.LayerOpacityChange(Sender: TObject);
begin
  if Selection is TBitmapLayer then
    TBitmapLayer(Selection).Bitmap.MasterAlpha := LayerOpacity.Position;
end;

procedure TMainForm.LayerRescaleClick(Sender: TObject);
var
  T: TBitmap32;
begin
  // resize the layer's bitmap to the size of the layer
  if Selection is TBitmapLayer then
    with TBitmapLayer(Selection) do
    begin
      T := TBitmap32.Create;
      T.Assign(Bitmap);
      with Rect(Location) do
        Bitmap.SetSize(Right - Left, Bottom - Top);
      T.StretchFilter := sfLinear;
      T.DrawMode := dmOpaque;
      T.DrawTo(Bitmap, Rect(0, 0, Bitmap.Width, Bitmap.Height));
      T.Free;
      LayerResetScaleClick(Self);
    end;
end;

procedure TMainForm.LayerResetScaleClick(Sender: TObject);
var
  L: TFloatRect;
begin
  // resize the layer to the size of its bitmap
  if Selection is TBitmapLayer then
    with RBLayer, TBitmapLayer(Selection).Bitmap do
    begin
      L := Location;
      L.Right := L.Left + Width;
      L.Bottom := L.Top + Height;
      Location := L;
      Changed;
    end;
end;

procedure TMainForm.MagnChange(Sender: TObject);
begin
  ImgView.Invalidate;
end;

procedure TMainForm.mnArrangeClick(Sender: TObject);
var
  B: Boolean;
begin
  B := Selection <> nil;
  mnBringFront.Enabled := B and (Selection.Index < ImgView.Layers.Count - 2);
  mnSendBack.Enabled := B and (Selection.Index > 0);
  mnLevelUp.Enabled := B and (Selection.Index < ImgView.Layers.Count - 2);
  mnLevelDown.Enabled := B and (Selection.Index > 0);
  mnScaled.Enabled := B;
  mnScaled.Checked := B and Selection.Scaled;
  mnDelete.Enabled := B;
end;

procedure TMainForm.mnDeleteClick(Sender: TObject);
var
  ALayer: TPositionedLayer;
begin
  if Selection <> nil then
  begin
    ALayer := Selection;
    Selection := nil;
    ALayer.Free;
  end;
end;

procedure TMainForm.mnFileNewClick(Sender: TObject);
begin
  with NewImageForm do
  begin
    ShowModal;
    if ModalResult = mrOK then
      CreateNewImage(UpDown1.Position, UpDown2.Position, Color32(Panel1.Color));
  end;
end;

procedure TMainForm.mnFileOpenClick(Sender: TObject);
begin
  with OpenPictureDialog1 do
    if Execute then OpenImage(FileName);
end;

procedure TMainForm.mnLayersClick(Sender: TObject);
var
  B: Boolean;
begin
  B := not ImgView.Bitmap.Empty;
  mnNewBitmapLayer.Enabled := B;
  mnNewBitmapRGBA.Enabled := B;
  mnNewCustomLayer.Enabled := B;
end;

procedure TMainForm.mnMagnifierClick(Sender: TObject);
var
  L: TPositionedLayer;
begin
  L := CreatePositionedLayer;
  L.OnPaint := PaintMagnifierHandler;
  L.Tag := 2;
  Selection := L;
end;

procedure TMainForm.mnNewBitmapLayerClick(Sender: TObject);
var
  B: TBitmapLayer;
  P: TPoint;
  W, H: Single;
begin
  with OpenPictureDialog1 do
    if Execute then
    begin
      B := TBitmapLayer.Create(ImgView.Layers);
      with B do
      try
        Bitmap.LoadFromFile(FileName);
        Bitmap.DrawMode := dmBlend;

        with ImgView.GetViewportRect do
          P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

        W := Bitmap.Width / 2;
        H := Bitmap.Height / 2;

        with ImgView.Bitmap do
          Location := FloatRect(P.X - W, P.Y - H, P.X + W, P.Y + H);

        Scaled := True;
        OnMouseDown := LayerMouseDown;
      except
        Free;
        raise;
      end;
      Selection := B;
    end;
end;

procedure TMainForm.mnNewBitmapRGBAClick(Sender: TObject);
var
  B: TBitmapLayer;
  P: TPoint;
  Tmp: TBitmap32;
  W, H: Single;
begin
  with RGBALoaderForm do
  begin
    ImgRGB.Bitmap.Delete;
    ImgRGB.Scale := 1;
    ImgAlpha.Bitmap.Delete;
    ImgAlpha.Scale := 1;
    ShowModal;
    if (ModalResult = mrOK) and not ImgRGB.Bitmap.Empty then
    begin
      B := TBitmapLayer.Create(ImgView.Layers);
      B.Bitmap := ImgRGB.Bitmap;
      B.Bitmap.DrawMode := dmBlend;

      if not ImgAlpha.Bitmap.Empty then
      begin
        Tmp := TBitmap32.Create;
        try
          Tmp.SetSize(B.Bitmap.Width, B.Bitmap.Height);
          ImgAlpha.Bitmap.DrawTo(Tmp, Rect(0, 0, Tmp.Width, Tmp.Height));

          // combine Alpha into already loaded RGB colors
          IntensityToAlpha(B.Bitmap, Tmp);
        finally
          Tmp.Free;
        end;
      end;

      with ImgView.GetViewportRect do
        P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

      with B do
      begin
        W := Bitmap.Width / 2;
        H := Bitmap.Height / 2;

        with ImgView.Bitmap do
          Location := FloatRect(P.X - W, P.Y - H, P.X + W, P.Y + H);

        Scaled := True;
        OnMouseDown := LayerMouseDown;
      end;
      Selection := B;
    end;
  end;
end;

procedure TMainForm.mnReorder(Sender: TObject);
begin
  // note that the top-most layer is occupied with the rubber-banding layer
  if Selection <> nil then
    case TMenuItem(Sender).Tag of
      1: // Bring to front, do not use BringToFront here, see note above
        Selection.Index := ImgView.Layers.Count - 2;
      2: Selection.SendToBack;
      3: Selection.Index := Selection.Index + 1; // up one level
      4: Selection.Index := Selection.Index - 1; // down one level
    end;
end;

procedure TMainForm.mnSimpleDrawingClick(Sender: TObject);
var
  L: TPositionedLayer;
begin
  L := CreatePositionedLayer;
  L.OnPaint := PaintSimpleDrawingHandler;
  L.Tag := 1;
  Selection := L;
end;

procedure TMainForm.OpenImage(const FileName: string);
begin
  with ImgView do
  try
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.LoadFromFile(FileName);
  finally
    pnlImage.Visible := not Bitmap.Empty;
  end;
end;

procedure TMainForm.PaintMagnifierHandler(Sender: TObject; Buffer: TBitmap32);
var
  Magnification, Rotation: Single;
  SrcRect, DstRect: TFloatRect;
  R: TRect;
  T: TAffineTransformation;
  B: TBitmap32;
  W2, H2: Single;
  I: Integer;
begin
  if Sender is TPositionedLayer then
    with TPositionedLayer(Sender) do
    begin
      Magnification := Power(10, (MagnMagnification.Position / 50));
      Rotation := -MagnRotation.Position;

      DstRect := GetAdjustedLocation;
      R := Rect(DstRect);
      B := TBitmap32.Create;
      try
        with R do
        begin
          B.SetSize(Right - Left, Bottom - Top);
          W2 := (Right - Left) / 2;
          H2 := (Bottom - Top) / 2;
        end;

        SrcRect := DstRect;
        with SrcRect do
        begin
          Left := Left - H2;
          Right := Right + H2;
          Top := Top - W2;
          Bottom := Bottom + W2;
        end;

        T := TAffineTransformation.Create;
        try
          T.SrcRect := SrcRect;
          T.Translate(-R.Left, -R.Top);

          T.Translate(-W2, -H2);
          T.Scale(Magnification, Magnification);
          T.Rotate(0, 0, Rotation);
          T.Translate(W2, H2);

          if MagnInterpolate.Checked then
          begin
            Buffer.BeginUpdate;
            Buffer.StretchFilter := sfLinear;
            Transform(B, Buffer, T);
            Buffer.StretchFilter := sfNearest;
            Buffer.EndUpdate;
          end
          else
             Transform(B, Buffer, T);

          B.ResetAlpha;
          B.DrawMode := dmBlend;
          B.MasterAlpha := MagnOpacity.Position;
          B.DrawTo(Buffer, R);

          // draw frame
          for I := 0 to 4 do
          begin
             with R do Buffer.RaiseRectTS(Left, Top, Right, Bottom, 35 - I * 8);
             InflateRect(R, -1, -1);
          end;
        finally
          T.Free;
        end;
      finally
        B.Free;
      end;
    end;
end;

{ bidule qui trace la spirale }
{ on le transforme en traceur de croix }
procedure TMainForm.PaintSimpleDrawingHandler(Sender: TObject; Buffer: TBitmap32);
var
  Cx, Cy: Single;
  W2, H2: Single;
  I: Integer;
begin
  if Sender is TPositionedLayer then
    with TPositionedLayer(Sender).GetAdjustedLocation do
    begin
{      W2 := (Right - Left) / 2;
      H2 := (Bottom - Top) / 2;
      Buffer.PenColor := clRed32;
      Buffer.HorzLineS(round(Left),Round(W2),round(Right),clRed32);
      Buffer.VertLineS(Round(H2),round(Top),round(Bottom),clBlue32); }
      W2 := (Right - Left) / 2;
      H2 := (Bottom - Top) / 2;
      Cx := Left + W2;
      Cy := Top + H2;
      Buffer.PenColor := clRed32;
      Buffer.MoveToF(Cx,Cy);Buffer.LineToFS(Right,CY);
      Buffer.PenColor := clBlue32;
      Buffer.MoveToF(Cx,Cy);Buffer.LineToFS(Cx,Top);

      Buffer.MoveToF(Cx,Cy);
      for I := 0 to 240 do
      begin
        Buffer.LineToFS(Cx + W2 * I / 200 * Cos(I / 8), Cy + H2 * I / 200 * Sin(I / 8));
      end;
    end;
end;

procedure TMainForm.ScaleComboChange(Sender: TObject);
var
  S: string;
  I: Integer;
begin
  S := ScaleCombo.Text;
  S := StringReplace(S, '%', '', [rfReplaceAll]);
  S := StringReplace(S, ' ', '', [rfReplaceAll]);
  if S = '' then Exit;
  I := StrToIntDef(S, -1);
  if (I < 1) or (I > 2000) then I := Round(ImgView.Scale * 100)
  else ImgView.Scale := I / 100;
  ScaleCombo.Text := IntToStr(I) + '%';
  ScaleCombo.SelStart := Length(ScaleCombo.Text) - 1;
end;

procedure TMainForm.SetSelection(Value: TPositionedLayer);
begin
  if Value <> FSelection then
  begin
    if RBLayer <> nil then
    begin
      RBLayer.ChildLayer := nil;
      RBLayer.LayerOptions := 0; // disable both LOB_GDI_OVERLAY and LOB_MOUSE_EVENTS
{      pnlBitmapLayer.Visible := False; } { on laisse ces panneaux tout le temps affichs }
{      pnlMagn.Visible := False; }
      ImgView.Invalidate;
    end;

    FSelection := Value;

    if Value <> nil then
    begin
      if RBLayer = nil then
      begin
        RBLayer := TRubberBandLayer.Create(ImgView.Layers);
        RBLayer.MinHeight := 1;
        RBLayer.MinWidth := 1;
      end
      else RBLayer.BringToFront;
      RBLayer.ChildLayer := Value;
      RBLayer.LayerOptions := LOB_GDI_OVERLAY or LOB_MOUSE_EVENTS;
      RBLayer.OnMouseDown := RBMouseDown;

      if Value is TBitmapLayer then
        with TBitmapLayer(Value) do
        begin
          pnlBitmapLayer.Visible := True;
          LayerOpacity.Position := Bitmap.MasterAlpha;
          LayerInterpolate.Checked := Bitmap.StretchFilter = sfLinear;
        end
      else if Value.Tag = 2 then
      begin
        // tag = 2 for magnifiers
        pnlMagn.Visible := True;
      end;
    end;
  end;
end;

procedure TMainForm.WMEraseBkgnd(var Msg: TMessage);
begin
  // disable form background cleaning
  Msg.Result := 1;
end;

procedure TMainForm.mnScaledClick(Sender: TObject);
begin
  if Selection <> nil then Selection.Scaled := not Selection.Scaled;
  RBLayer.Scaled := Selection.Scaled;
end;

procedure TMainForm.RBMouseDown(Sender: TObject; Buttons: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // this event handler is called after the mouse button is pressed on top
  // of the rubber band layer
  with RBLayer do
    if ssCtrl in Shift then ResizeOptions := ResizeOptions + [rroSymmetrical]
    else ResizeOptions := ResizeOptions - [rroSymmetrical];

end;

{ ===================== }
{ F. OTT, rajouts }

procedure TMainForm.PaintData;
var
  P: PPalette32;
begin

  case PaletteCombo.ItemIndex of
    0: P := @palGrayScale;
    1: P := @palGreens;
    2: P := @palReds;
    3: P := @palRainbow;
  else
    P := @palCustom;
  end;
  DataSet.WriteTo(ImgView.Bitmap, P^);
end;


procedure TMainForm.Replot1Click(Sender: TObject);
begin
  GenSampleData(Xmesh, Ymesh);
  PaintData;
end;

procedure TMainForm.PaletteComboChange(Sender: TObject);
begin
     PaintData;
end;

procedure TMainForm.ScaleBarChange(Sender: TObject);
var
  NewScale: Single;
begin
  NewScale := Power(10, (ScaleBar.Position) / 100);
  ScaleBar.Repaint;
  ImgView.ScaleMode := SmScale;
  ImgView.Scale := NewScale;
  CurrentScale:=NewScale;
end;

{ on va bricoler l'autostrech }
procedure TMainForm.StretchButtonClick(Sender: TObject);
var
  NewScale1,NewScale2: Single;
begin
{ IL faut tenir compte de la taille des ascenseurs }
{ UTILISER GetViewPortRect                         }
  NewScale1:=abs(ImgView.GetViewPortRect.Left-ImgView.GetViewPortRect.Right)/Xmesh;
  NewScale2:=abs(ImgView.GetViewPortRect.Top-ImgView.GetViewPortRect.Bottom)/Ymesh;
  CurrentScale:=min(NewScale1,NewScale2);
  ImgView.Scale := CurrentScale;
  {  ImgView.ScaleMode := SmStretch;  } { ne fonctionne pas en ImgView32 ?!? }

end;

procedure TMainForm.PaletteCenterGaugeBarChange(Sender: TObject);
var
  i: Integer;
  f: Single;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    PalCustom[i]:= HSLtoRGB(0, 0, PaletteAmplitudeGaugeBar.position/100 * f + PaletteCenterGaugeBar.position/100);
  end;
  PaintData;
end;

procedure TMainForm.PaletteAmplitudeGaugeBarChange(Sender: TObject);
var
  i: Integer;
  f: Single;
begin
  for i := 0 to 255 do
  begin
    f := i / 255;
    PalCustom[i]:= HSLtoRGB(0, 0, PaletteAmplitudeGaugeBar.position/100 * f + PaletteCenterGaugeBar.position/100);
  end;
  PaintData;
end;


procedure TMainForm.CreateData3D1Click(Sender: TObject);
var i,j:integer;
begin
     Xmesh:=128;Ymesh:=128;
     setLength(MesData3D,Xmesh+1,Ymesh+1);
     xmin:=0;xmax:=128;ymin:=0;ymax:=128;
     for i:=0 to Xmesh do
         for j:=0 to Ymesh do MesData3D[i,j]:=power(10,(sin(i/12)*cos(j/12)));
     zmin:=-1;zmax:=+1;
end;

{ ================================= }
{ Partie pour le trac des curseurs }

procedure TMainForm.Draw;
begin
  ImgView.Bitmap.BeginUpdate;
  ImgView.Bitmap.Clear(clWhite32);
{  ImgView.Bitmap.Draw(50, 50, BitmapList.Bitmaps[0].Bitmap); } { cette ligne ne marche pas }
{ on essaie ca }  PaintData;
  PolygonH1.Antialiased := false; {Antialiase.Checked; }
  PolygonV1.Antialiased := false; {Antialiase.Checked; }
  PolygonH1.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonV1.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonH1.DrawEdge(ImgView.Bitmap, SetAlpha(clMaroon32, 255));
  PolygonV1.DrawEdge(ImgView.Bitmap, SetAlpha(clRed32, 255));
  PolygonH2.Antialiased := false; {Antialiase.Checked; }
  PolygonV2.Antialiased := false; {Antialiase.Checked; }
  PolygonH2.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonV2.DrawFill(ImgView.Bitmap, SetAlpha(clGreen32, 255));
  PolygonH2.DrawEdge(ImgView.Bitmap, SetAlpha(clNavy32, 255));
  PolygonV2.DrawEdge(ImgView.Bitmap, SetAlpha(clBlue32, 255));

  PolygonD.Antialiased := false; {Antialiase.Checked; }
  PolygonD.DrawEdge(ImgView.Bitmap, SetAlpha(clGreen32, 255));

  ImgView.Bitmap.EndUpdate;
  ImgView.Bitmap.Changed;
  ImgView.Refresh; // force repaint
end;

procedure TMainForm.Zval1Change(Sender: TObject);
begin

end;

{ procedure pour mettre  jour les champs des courbes a afficher }
procedure TMainForm.UpdateCourbesAafficher;
begin
  if (typeGraphCombo.text='Horizontales')
  then begin
       xyCoupe[CoupeHorz1].active:=true;
       xyCoupe[CoupeHorz2].active:=true;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       end;
  if (typeGraphCombo.text='Curseur 1')
  then begin
       xyCoupe[CoupeHorz1].active:=true;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=true;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       end;
  if (typeGraphCombo.text='Verticales')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=true;
       xyCoupe[CoupeVert2].active:=true;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       end;
  if (typeGraphCombo.text='Curseur 2')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=true;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=true;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=false;
       end;
  if (typeGraphCombo.text='DiagonaleX')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=true;
       xyCoupe[CoupeDiagY].active:=false;
       end;
  if (typeGraphCombo.text='DiagonaleY')
  then begin
       xyCoupe[CoupeHorz1].active:=false;
       xyCoupe[CoupeHorz2].active:=false;
       xyCoupe[CoupeVert1].active:=false;
       xyCoupe[CoupeVert2].active:=false;
       xyCoupe[CoupeDiagX].active:=false;
       xyCoupe[CoupeDiagY].active:=true;
       end;
end;

{ changement des courbes a afficher  dans le graph1D }
{ en fonction de ce qui est demand dans la combobox }
procedure TMainForm.TypeGraphComboChange(Sender: TObject);
begin
  UpdateCourbesAafficher
end;

procedure TMainForm.ZminBoxExit(Sender: TObject);
begin
   zmin:=zminbox.value;zmax:=zmaxbox.value;
   GenSampleData(Xmesh, Ymesh);
   PaintData;
end;

procedure TMainForm.ZmaxBoxExit(Sender: TObject);
begin
   zmin:=zminbox.value;zmax:=zmaxbox.value;
   GenSampleData(Xmesh, Ymesh);
   PaintData;
end;

procedure TMainForm.ZlogCheckBoxClick(Sender: TObject);
begin
     if (zmin>0) and (zmax>0)
     then begin
          GenSampleData(Xmesh, Ymesh);PaintData;
          end
     else begin
          ZlogCheckBox.checked:=false;ZlogCheckBox.update;
          MessageDlg('You need a positive Z range',mtError,[mbOk],0);
          end;
end;

end.
